package com.xlht.xlhtproject.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.xlht.xlhtproject.respParse.bean.AjaxResult;
import com.xlht.xlhtproject.respParse.page.TableDataInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.xlht.xlhtproject.domain.ZAssayResult;
import com.xlht.xlhtproject.service.IZAssayResultService;


/**
 * 化验结果明细Controller
 * 
 * @author slibra
 * @date 2024-09-19
 */
@RestController
@RequestMapping("/business/result")
public class ZAssayResultController extends BaseController
{
    @Autowired
    private IZAssayResultService zAssayResultService;

    /**
     * 查询化验结果明细列表
     */
    @GetMapping("/list")
    public TableDataInfo list(ZAssayResult zAssayResult)
    {
        startPage();
        List<ZAssayResult> list = zAssayResultService.selectZAssayResultList(zAssayResult);
        return getDataTable(list);
    }

   /* *//**
     * 导出化验结果明细列表
     *//*
    @PostMapping("/export")
    public void export(HttpServletResponse response, ZAssayResult zAssayResult)
    {
        List<ZAssayResult> list = zAssayResultService.selectZAssayResultList(zAssayResult);
        ExcelUtil<ZAssayResult> util = new ExcelUtil<ZAssayResult>(ZAssayResult.class);
        util.exportExcel(response, list, "化验结果明细数据");
    }*/

    /**
     * 获取化验结果明细详细信息
     */
    @GetMapping(value = "/{resultId}")
    public AjaxResult getInfo(@PathVariable("resultId") Long resultId)
    {
        return success(zAssayResultService.selectZAssayResultByResultId(resultId));
    }

    /**
     * 新增化验结果明细
     */
    @PostMapping
    public AjaxResult add(@RequestBody ZAssayResult zAssayResult)
    {
        return toAjax(zAssayResultService.insertZAssayResult(zAssayResult));
    }

    /**
     * 修改化验结果明细
     */
    @PutMapping
    public AjaxResult edit(@RequestBody ZAssayResult zAssayResult)
    {
        return toAjax(zAssayResultService.updateZAssayResult(zAssayResult));
    }

    /**
     * 删除化验结果明细
     */
	@DeleteMapping("/{resultIds}")
    public AjaxResult remove(@PathVariable Long[] resultIds)
    {
        return toAjax(zAssayResultService.deleteZAssayResultByResultIds(resultIds));
    }
}
