package com.xlht.xlhtproject.mapper;

import com.xlht.xlhtproject.domain.TXlhtAddRecord;

import java.util.List;

/**
 * 锡林浩特投药记录Mapper接口
 * 
 * @author slibra
 * @date 2024-10-13
 */
public interface TXlhtAddRecordMapper 
{
    /**
     * 查询锡林浩特投药记录
     * 
     * @param id 锡林浩特投药记录主键
     * @return 锡林浩特投药记录
     */
    public TXlhtAddRecord selectTXlhtAddRecordById(Long id);

    /**
     * 查询锡林浩特投药记录列表
     * 
     * @param tXlhtAddRecord 锡林浩特投药记录
     * @return 锡林浩特投药记录集合
     */
    public List<TXlhtAddRecord> selectTXlhtAddRecordList(TXlhtAddRecord tXlhtAddRecord);

    /**
     * 新增锡林浩特投药记录
     * 
     * @param tXlhtAddRecord 锡林浩特投药记录
     * @return 结果
     */
    public int insertTXlhtAddRecord(TXlhtAddRecord tXlhtAddRecord);

    /**
     * 修改锡林浩特投药记录
     * 
     * @param tXlhtAddRecord 锡林浩特投药记录
     * @return 结果
     */
    public int updateTXlhtAddRecord(TXlhtAddRecord tXlhtAddRecord);

    /**
     * 删除锡林浩特投药记录
     * 
     * @param id 锡林浩特投药记录主键
     * @return 结果
     */
    public int deleteTXlhtAddRecordById(Long id);

    /**
     * 批量删除锡林浩特投药记录
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXlhtAddRecordByIds(Long[] ids);

    TXlhtAddRecord selectLatestTXlhtAddRecord();

    List<TXlhtAddRecord> getNAddRecords(long counts);
}
