package com.xlht.xlhtproject.service.impl;

import java.util.Collections;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.xlht.xlhtproject.mapper.TShuju1Mapper;
import com.xlht.xlhtproject.domain.TShuju1;
import com.xlht.xlhtproject.service.ITShuju1Service;

/**
 * 入库数据_5分钟间隔Service业务层处理
 * 
 * @author slibra
 * @date 2024-09-19
 */
@Service
public class TShuju1ServiceImpl implements ITShuju1Service
{
    @Autowired
    private TShuju1Mapper tShuju1Mapper;

    /**
     * 查询入库数据_5分钟间隔
     * 
     * @param ID 入库数据_5分钟间隔主键
     * @return 入库数据_5分钟间隔
     */
    @Override
    public TShuju1 selectTShuju1ByID(Long ID)
    {
        return tShuju1Mapper.selectTShuju1ByID(ID);
    }

    /**
     * 查询入库数据_5分钟间隔列表
     * 
     * @param tShuju1 入库数据_5分钟间隔
     * @return 入库数据_5分钟间隔
     */
    @Override
    public List<TShuju1> selectTShuju1List(TShuju1 tShuju1)
    {
        return tShuju1Mapper.selectTShuju1List(tShuju1);
    }

    /**
     * 新增入库数据_5分钟间隔
     * 
     * @param tShuju1 入库数据_5分钟间隔
     * @return 结果
     */
    @Override
    public int insertTShuju1(TShuju1 tShuju1)
    {
        return tShuju1Mapper.insertTShuju1(tShuju1);
    }

    /**
     * 修改入库数据_5分钟间隔
     * 
     * @param tShuju1 入库数据_5分钟间隔
     * @return 结果
     */
    @Override
    public int updateTShuju1(TShuju1 tShuju1)
    {
        return tShuju1Mapper.updateTShuju1(tShuju1);
    }

    /**
     * 批量删除入库数据_5分钟间隔
     * 
     * @param IDs 需要删除的入库数据_5分钟间隔主键
     * @return 结果
     */
    @Override
    public int deleteTShuju1ByIDs(Long[] IDs)
    {
        return tShuju1Mapper.deleteTShuju1ByIDs(IDs);
    }

    /**
     * 删除入库数据_5分钟间隔信息
     * 
     * @param ID 入库数据_5分钟间隔主键
     * @return 结果
     */
    @Override
    public int deleteTShuju1ByID(Long ID)
    {
        return tShuju1Mapper.deleteTShuju1ByID(ID);
    }

    @Override
    public List<TShuju1> selectTShuju1ListGroupByAssayId(TShuju1 req) {
        return tShuju1Mapper.selectTShuju1ListGroupByAssayId(req);
    }
}
